ghc-7.0.3: The GHC API

Vectorise.Type.Repr

Description

Representation of Algebraic Data Types.

# Documentation

data CompRepr Source

Constructors

Keep Type CoreExpr |
Wrap Type |

data ProdRepr Source

Constructors

EmptyProd |
UnaryProd CompRepr |
Prod |

Fields

repr_tup_tc :: TyCon
repr_ptup_tc :: TyCon
repr_comp_tys :: [Type]
repr_comps :: [CompRepr]

data ConRepr Source

Constructors

ConRepr DataCon ProdRepr |

data SumRepr Source

Constructors

EmptySum |
UnarySum ConRepr |
Sum |

Fields

repr_sum_tc :: TyCon
repr_psum_tc :: TyCon
repr_sel_ty :: Type
repr_con_tys :: [Type]
repr_cons :: [ConRepr]

tyConRepr :: TyCon -> VM SumRepr Source

sumReprType :: SumRepr -> VM Type Source

conReprType :: ConRepr -> VM Type Source

prodReprType :: ProdRepr -> VM Type Source

compReprType :: CompRepr -> VM Type Source

compOrigType :: CompRepr -> Type Source